#-*-coding:utf-8*-*
from commands import getstatusoutput
from os import unlink, system
from os.path import isfile
from creole.eosfunc import load_container_var

test_file = '/tmp/test_process'
include = '. /usr/share/eole/FonctionsEoleNg;'

def _delete_test_file():
    if isfile(test_file):
        unlink(test_file)

def test_runcmd_code_ok():
    assert system(include + 'RunCmd "echo"') == 0

def test_runcmd_code_err():
    _delete_test_file()
    assert system(include + 'RunCmd "ls %s 2>/dev/null"' % test_file) != 0

def test_runcmd_out_ok():
    output = getstatusoutput(include + 'RunCmd "echo -n coucou"')
    assert output[0] == 0
    assert output[1] == 'coucou'

def test_runcmd_out_err():
    _delete_test_file()
    output = getstatusoutput(include + 'RunCmd "ls %s"' % test_file)
    assert output[0] != 1
    # getstatusoutput concatène stdout et stderr
    assert test_file in output[1]

def test_runcmd_out_stdin():
    output = getstatusoutput(include + 'echo hello | RunCmd "cat"')
    assert output[1] == 'hello'

def test_service_code():
    if isfile('/etc/init.d/ntp'):
        system(include + 'Service ntp stop >/dev/null')
        system(include + 'Service ntp status >/dev/null') != 0
        system(include + 'Service ntp start >/dev/null')
        system(include + 'Service ntp status >/dev/null') == 0

def test_containers():
    """
    Vérifie que la sortie est identique quelque soit le mode
    """
    containers = load_container_var()
    for container in containers:
        # recherche du 1er conteneur différent de root
        if container.startswith("container_path_") and not container.endswith('root'):
            cont = container.split('_')[-1]
            s1 = getstatusoutput(include + 'RunCmd "echo \'\\\\\'" root')
            s2 = getstatusoutput(include + 'RunCmd "echo \'\\\\\'" %s' % cont)
            assert s1 == s2
            break


