#-*-coding:utf-8*-*
from os import unlink
from os.path import isfile
from creole.eosfunc import load_container_var
from pyeole.process import system_code, system_out
from pyeole.service import service_code

test_file = '/tmp/test_process'

def _delete_test_file():
    if isfile(test_file):
        unlink(test_file)

def test_system_code_ok():
    assert system_code(['echo']) == 0

def test_system_code_err():
    _delete_test_file()
    assert system_code(['ls', test_file]) == 2

def test_system_out_ok():
    output = system_out(['echo', '-n', 'coucou'])
    assert output[0] == 0
    assert output[1] == 'coucou'
    assert output[2] == ''

def test_system_out_err():
    _delete_test_file()
    output = system_out(['ls', test_file])
    assert output[0] == 2
    assert output[1] == ''
    assert test_file in output[2]

def test_system_out_stdin():
    assert system_out(['cat'], stdin='hello')[1] == 'hello'

def test_service_code():
    if isfile('/etc/init.d/ntp'):
        service_code('ntp', 'stop')
        assert service_code('ntp', 'status') != 0
        service_code('ntp', 'start')
        assert service_code('ntp', 'status') == 0

def test_containers():
    """
    Vérifie que la sortie est identique quelque soit le mode
    """
    containers = load_container_var()
    for container in containers:
        # recherche du 1er conteneur différent de root
        if container.startswith("container_path_") and not container.endswith('root'):
            cont = container.split('_')[-1]
            test1 = system_out(['echo', '////"\''], container=cont)
            test2 = system_out(['echo', '////"\''], container='root')
            assert test1 == test2
            break

